/******************************************************/
/**  Dummy Time() procedure so that Dhrystone works  **/
/**  This only works if program run time is < 65 sec **/
/******************************************************/
#ifdef MCF5307
  #include "sim5307.h"

  static volatile SIM5307 *sim = (SIM5307 *)0x10000000;
#else
  #include "sim5206.h"

  static volatile SIM5206 *sim = (SIM5206 *)0x10000000;
#endif


long time()
{
#if defined(MCF5307)
  return (sim->timer1.tcn * 1000) / 11250; /* 45MHz bus speed */
#elif defined(MCF5206e)
  return (sim->timer1.tcn * 1000) / 13500; /* 54MHz bus speed */
#else
  return (sim->timer1.tcn * 1000) / 6250; /* 25MHz bus speed */
#endif
}


void Init_Timer( void )
{
  /* Enable the ColdFire cache */
#ifndef MCF5307
  __asm__ __volatile__(" nop
        move.l  #0x80000000,%d0
        movec   %d0,%cacr
	nop ");
#else
  __asm__ __volatile__(" nop
        move.l  #0x81000300,%d0
        movec   %d0,%cacr
	nop 
	move.l  #0x0000C000,%d0
        movec   %d0,%acr0
        nop ");

#endif


  /* Reset Timer */

  sim->timer1.tmr = sim->timer1.tmr | 0x0001; /* enable timer */
  sim->timer1.tmr = sim->timer1.tmr | 0x0000; /* reset timer */
  sim->timer1.tmr = sim->timer1.tmr | 0x0001; /* re-enable timer */
  sim->timer1.tcn = 0; /* zero count */

  /* Setup Timer */
  sim->timer1.tmr = sim->timer1.tmr & 0xFFF9; /* input clock bits = 00 to stop timer */
  sim->timer1.tmr = (sim->timer1.tmr & 0x00FF) | 0xFA00; /* Set prescale to 1/250 */

  /* Start the timer running */
  sim->timer1.tmr = (sim->timer1.tmr & 0xFFF9) | 0x0004; /* Set Master_Clk/16 and start */
}




